## golang-github-kentik-patricia 0.0~git20200128.c35d94c

=== debian/changelog ===
golang-github-kentik-patricia (0.0~git20200128.c35d94c-2) unstable; urgency=medium

  * Re-upload to unstable.

 -- Marco d'Itri <md@linux.it>  Wed, 22 Apr 2020 05:11:06 +0200

golang-github-kentik-patricia (0.0~git20200128.c35d94c-1) experimental; urgency=medium

  * Initial release.

 -- Marco d'Itri <md@linux.it>  Sun, 19 Apr 2020 05:52:21 +0200

=== debian/rules ===
#!/usr/bin/make -f
export DH_GOLANG_INSTALL_EXTRA := template/test_tags.tsv

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

## golang-github-kentik-patricia 0.0~git20201202.f9447a6

=== Makefile ===
_GOPATH 			:= $(PWD)/../../../..
export GOPATH := $(_GOPATH)
GENERATED_TYPES := bool string int int8 int16 int32 int64 uint uint8 uint16 uint32 uint64 byte rune float32 float64 complex64 complex128
# on mac use gsed
UNAME_S = $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
	SED = gsed
else
	SED = sed
endif

.PHONY: all
all: codegen code

ipv6code:
	cp template/tree_v4.go template/tree_v6_generated.go
	$(SED) -i -e 's/TreeV4/TreeV6/g' template/tree_v6_generated.go
	$(SED) -i -e 's/treeNodeV4/treeNodeV6/g' template/tree_v6_generated.go
	$(SED) -i -e 's/IPv4Address/IPv6Address/g' template/tree_v6_generated.go

codegen: ipv6code $(addprefix codegen-,$(GENERATED_TYPES))

codegen-%:
	@echo "** generating $* tree"
	mkdir -p "./${*}_tree"
	cp -pa template/*.go "./${*}_tree"
	rm -f ./${*}_tree/*_test.go
	rm -f ./${*}_tree/types.go
	( cd "${*}_tree" && $(SED) -i "s/GeneratedType/${*}/g" *.go )
	( cd "${*}_tree" && $(SED) -i "s/package template/package ${*}_tree/g" *.go )

.PHONY: clean
clean:
	rm -rf *_tree
	rm -f template/tree_v6_generated.go

.PHONY: code
code:
	go build `go list ./... | grep -v /vendor/ `

.PHONY: test
test:
	go test -v `go list ./... | grep -v /vendor/ `

=== debian/changelog ===
golang-github-kentik-patricia (0.0~git20201202.f9447a6-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Marco d'Itri <md@linux.it>  Sun, 03 Jan 2021 09:09:36 +0100

golang-github-kentik-patricia (0.0~git20200128.c35d94c-3) UNRELEASED; urgency=low

  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Debian Janitor <janitor@jelmer.uk>  Sun, 30 Aug 2020 17:22:49 -0000

=== debian/control ===
Source: golang-github-kentik-patricia
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Marco d'Itri <md@linux.it>
Section: devel
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               golang-any,
               golang-github-stretchr-testify-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia.git
Homepage: https://github.com/kentik/patricia
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/kentik/patricia

Package: golang-github-kentik-patricia-dev
Architecture: all
Depends: ${misc:Depends}
Description: Garbage collector-sensitive patricia tree (library)
 Go implementation of a patricia tree, specifically for tagging IPv4 and
 IPv6 addresses with CIDR bits, with a focus on producing as little
 garbage for the garbage collector to manage as possible.
 This allows you to tag millions of IP addresses without incurring a
 penalty during GC scanning.

=== debian/rules ===
--- 
+++ 
@@ -3,4 +3,3 @@
 
 %:
 	dh $@ --builddirectory=_build --buildsystem=golang --with=golang
-

## golang-github-kentik-patricia 0.0~git20210909.2160333

=== debian/changelog ===
golang-github-kentik-patricia (0.0~git20210909.2160333-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Marco d'Itri <md@linux.it>  Sat, 18 Sep 2021 23:45:55 +0200

## golang-github-kentik-patricia 1.0.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-_GOPATH 			:= $(PWD)/../../../..
-export GOPATH := $(_GOPATH)
 GENERATED_TYPES := bool string int int8 int16 int32 int64 uint uint8 uint16 uint32 uint64 byte rune float32 float64 complex64 complex128
 # on mac use gsed
 UNAME_S = $(shell uname -s)
@@ -36,8 +34,8 @@
 
 .PHONY: code
 code:
-	go build `go list ./... | grep -v /vendor/ `
+	go build -v ./...
 
 .PHONY: test
 test:
-	go test -v `go list ./... | grep -v /vendor/ `
+	go test -v ./... --cover --race

=== debian/changelog ===
golang-github-kentik-patricia (1.0.0-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + golang-github-kentik-patricia-dev: Add Multi-Arch: foreign.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 07 Dec 2022 21:53:44 +0000

golang-github-kentik-patricia (1.0.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.6.1, no changes needed.
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 17 Oct 2022 14:28:15 +0100

golang-github-kentik-patricia (1.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Marco d'Itri <md@linux.it>  Tue, 17 May 2022 02:23:28 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Section: devel
 Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-stretchr-testify-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia.git
 Homepage: https://github.com/kentik/patricia
@@ -18,6 +18,7 @@
 Package: golang-github-kentik-patricia-dev
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Garbage collector-sensitive patricia tree (library)
  Go implementation of a patricia tree, specifically for tagging IPv4 and
  IPv6 addresses with CIDR bits, with a focus on producing as little

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/kentik/patricia.git \
  HEAD debian

## golang-github-kentik-patricia 1.2.1

=== Makefile ===
--- 
+++ 
@@ -10,20 +10,44 @@
 .PHONY: all
 all: codegen code
 
+.PHONY: ipv6code generics codegen codegen-%
+codegen: ipv6code generics $(addprefix codegen-,$(GENERATED_TYPES))
+
 ipv6code:
 	cp template/tree_v4.go template/tree_v6_generated.go
+	$(SED) -i -e 's/Template file./Code generated by automation. DO NOT EDIT/' template/tree_v6_generated.go
 	$(SED) -i -e 's/TreeV4/TreeV6/g' template/tree_v6_generated.go
+	$(SED) -i -e 's/TreeIteratorV4/TreeIteratorV6/g' template/tree_v6_generated.go
 	$(SED) -i -e 's/treeNodeV4/treeNodeV6/g' template/tree_v6_generated.go
 	$(SED) -i -e 's/IPv4Address/IPv6Address/g' template/tree_v6_generated.go
 
-codegen: ipv6code $(addprefix codegen-,$(GENERATED_TYPES))
+generics: codegen-generics
+	# generics -> T, except in tests
+	( cd generics_tree && $(SED) -i -E -e 's/\bgenerics\b/string/g' *_test.go)
+	( cd generics_tree && $(SED) -i -E -e 's/\bgenerics\b/T/g' *.go)
+	# Each defined type should be parametrized with T
+	( cd generics_tree && $(SED) -nE 's/^type (\w+).*/\1/p' *.go \
+	        | grep -vFx treeIteratorNext \
+	        | grep -vFx deleteNodeResult \
+		| while read T; do \
+			$(SED) -i -E -e 's/\b'$$T'\b/\0[T]/g' *.go ; \
+			$(SED) -i -E -e 's/\b('$$T')\[T\]/\1[string]/g' *_test.go ; \
+		  done )
+	# Fix type definition
+	( cd generics_tree && $(SED) -i -E -e 's/^(type \w+)\[T\]/\1[T any]/' *.go)
+	# NewTreeVX function should be parametrized
+	( cd generics_tree && $(SED) -i -E -e 's/^(func NewTreeV.)/\1[T any]/' *.go)
+	( cd generics_tree && $(SED) -i -E -e 's/(NewTreeV.)\(/\1[string](/g' *_test.go)
+	# No need to cast interfaces
+	( cd generics_tree && $(SED) -i -E -e 's/\.\(string\)//g' *_test.go)
 
 codegen-%:
 	@echo "** generating $* tree"
 	mkdir -p "./${*}_tree"
 	cp -pa template/*.go "./${*}_tree"
-	rm -f ./${*}_tree/*_test.go
+	test "${*}" = generics || rm -f ./${*}_tree/*_test.go
 	rm -f ./${*}_tree/types.go
+	( cd "${*}_tree" && $(SED) -i "s/Template file./Code generated by automation. DO NOT EDIT/g" *.go )
 	( cd "${*}_tree" && $(SED) -i "s/GeneratedType/${*}/g" *.go )
 	( cd "${*}_tree" && $(SED) -i "s/package template/package ${*}_tree/g" *.go )

=== debian/changelog ===
golang-github-kentik-patricia (1.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Marco d'Itri <md@linux.it>  Sun, 20 Oct 2024 23:40:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: golang-github-kentik-patricia
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Marco d'Itri <md@linux.it>
-Section: devel
+Section: golang
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-stretchr-testify-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia.git
 Homepage: https://github.com/kentik/patricia

=== debian/rules ===
#!/usr/bin/make -f
export DH_GOLANG_INSTALL_EXTRA := test_tags.tsv

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

=== debian/watch ===
version=4
opts=filenamemangle=s/(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
    https://github.com/kentik/patricia/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## golang-github-kentik-patricia 1.2.2

=== debian/changelog ===
golang-github-kentik-patricia (1.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Marco d'Itri <md@linux.it>  Sun, 11 Jan 2026 01:36:51 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                dh-golang,
                golang-any,
                golang-github-stretchr-testify-dev
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.3.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-kentik-patricia.git
 Homepage: https://github.com/kentik/patricia
